<template>
  <section id="form" class="container mx-auto max-w-4xl">
    <div v-if="form">
      <div v-for="(item, index) in form.properties" :key="item.key + index">
        <h1 v-if="item.display === 'title'" class="text-4xl font-bold">
          <p class="my-1">{{ item.value }}</p>
        </h1>
        <div
          v-if="item.display === 'separator'"
          class="border-b-2 border-primary -mt-4"
        >
          &nbsp
        </div>
        <div v-else-if="item.display === 'input'" class="my-2">
          <p class="my-1 text-gray-600 text-sm font-semibold">
            {{ item.label }}:
          </p>
          <input
            :type="item.type"
            v-model="item.value"
            :placeholder="item.placeholder"
            class="p-2 w-full rounded-md"
          />
        </div>
        <div v-else-if="item.display === 'textarea'" class="my-2">
          <p class="my-1 text-gray-600 text-sm font-semibold">
            {{ item.label }}:
          </p>
          <textarea
            :type="item.type"
            v-model="item.value"
            :placeholder="item.placeholder"
            class="p-2 w-full rounded-md"
          />
        </div>
      </div>
      <div class="py-4 text-center mx-auto">
        <div
          class="px-4 py-2 bg-primary hover:shadow-xl hover:bg-gray-900 hover:scale-110 rounded-md text-light font-semibold w-1/5 mx-auto transition duration-300 cursor-pointer"
          @click="submit()"
        >
          Submit
        </div>
      </div>
    </div>
  </section>
</template>
<script>
export default {
  mounted() {
    //Get forms from localStorage
    let forms = JSON.parse(localStorage.getItem('forms'))

    // Return form if it exists
    this.form = forms.filter((item) => item?.id === this.$route.params.id)[0]
  },
  data() {
    return {
      form: null,
    }
  },
  methods: {
    async submit() {
      let data = {}
      this.form.properties.map((item) => {
        if (item.type) {
          data[item.key] = item.value
        }
      })

      this.form.headers.map((item) => {
        this.$axios.setHeader(item.key, item.value)
      })

      await this.$axios
        .post(this.form.target, data)
        .then((response) => {
          console.log(response)
          alert('Success !')
        })
        .catch((error) => {
          console.error(error)
          alert('Error ! Check console for more informations.')
        })
    },
  },
}
</script>
